#ifndef SBK_KActionMenuWrapper_H
#define SBK_KActionMenuWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <kactionmenu.h>

namespace PySide { class DynamicQMetaObject; }

class KActionMenuWrapper : public KActionMenu
{
public:
    KActionMenuWrapper(const KActionMenuWrapper &) = delete;
    KActionMenuWrapper& operator=(const KActionMenuWrapper &) = delete;
    KActionMenuWrapper(KActionMenuWrapper &&) = delete;
    KActionMenuWrapper& operator=(KActionMenuWrapper &&) = delete;

    KActionMenuWrapper(::QObject * parent);
    KActionMenuWrapper(const ::QIcon & icon, const ::QString & text, ::QObject * parent);
    KActionMenuWrapper(const ::QString & text, ::QObject * parent);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QWidget * createWidget(::QWidget * parent) override;
    void customEvent(::QEvent * event) override;
    void deleteWidget(::QWidget * widget) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * arg__1, ::QEvent * arg__2) override;
    void timerEvent(::QTimerEvent * event) override;
    ~KActionMenuWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_KActionMenuWrapper_H

