#ifndef SBK_KToolBarPopupActionWrapper_H
#define SBK_KToolBarPopupActionWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <ktoolbarpopupaction.h>

namespace PySide { class DynamicQMetaObject; }

class KToolBarPopupActionWrapper : public KToolBarPopupAction
{
public:
    KToolBarPopupActionWrapper(const KToolBarPopupActionWrapper &) = delete;
    KToolBarPopupActionWrapper& operator=(const KToolBarPopupActionWrapper &) = delete;
    KToolBarPopupActionWrapper(KToolBarPopupActionWrapper &&) = delete;
    KToolBarPopupActionWrapper& operator=(KToolBarPopupActionWrapper &&) = delete;

    KToolBarPopupActionWrapper(const ::QIcon & icon, const ::QString & text, ::QObject * parent);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QWidget * createWidget(::QWidget * parent) override;
    void customEvent(::QEvent * event) override;
    void deleteWidget(::QWidget * widget) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * arg__1, ::QEvent * arg__2) override;
    void timerEvent(::QTimerEvent * event) override;
    ~KToolBarPopupActionWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_KToolBarPopupActionWrapper_H

