#ifndef SBK_KTwoFingerTapWrapper_H
#define SBK_KTwoFingerTapWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <ktwofingertap.h>

namespace PySide { class DynamicQMetaObject; }

class KTwoFingerTapWrapper : public KTwoFingerTap
{
public:
    KTwoFingerTapWrapper(const KTwoFingerTapWrapper &) = delete;
    KTwoFingerTapWrapper& operator=(const KTwoFingerTapWrapper &) = delete;
    KTwoFingerTapWrapper(KTwoFingerTapWrapper &&) = delete;
    KTwoFingerTapWrapper& operator=(KTwoFingerTapWrapper &&) = delete;

    KTwoFingerTapWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~KTwoFingerTapWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_KTwoFingerTapWrapper_H

